from PIL import Image
import numpy as np
import matplotlib.pyplot as plt
import random
from math import *

#nuance de noir :
deg =20

#importation photo du quadrilatère
#carre = Image.open("photocarregeogebra.PNG")
carre = Image.open("carregeogebra.PNG")
#pour geogebra : opacité 100% et épaisseur : 5

img1 = np.array(carre)
img1 = img1[:,:,:3] #enlève la transparence

#reconstruction du carré
car = []
for i in range(img1.shape[0]):
    for j in range (img1.shape[1]):
        if img1[i,j][0] < deg and img1[i,j][1] < deg and img1[i,j][2] < deg:
            car.append((j,i))
#pour trouver les extrémités
def extrem(T):
    A =T[0]
    for i in range (len(T)):
        if T[i][0] <= A[0] and T[i][1] <= A[1]:
            A = T[i]
    C = A
    for i in range (len(T)):
        if T[i][0] >= C[0] and T[i][1] >= C[1]:
            C = T[i]
    
    B = (A[0],C[1])
    D = (C[0],A[1])
    return A[0],A[1],B[0],B[1],C[0],C[1],D[0],D[1]    

            
# programme à insérer élève
from math import *

#CH1
def milieu (xA,yA,xC,yC):
    xX = (xA + xC)/2
    yX = (yA + yC)/2
    return (xX, yX)

def milieu2 (xD,yD,xB,yB):
    xY = (xD + xB)/2
    yY = (yD + yB)/2
    return (xY, yY)
#CH2
def longeur (xA,yA,xB,yB):
    return sqrt ((xB-xA)**2+(yB-yA)**2)

#CH3
def Trectangle (xA,yA,xB,yB,xC,yC):
    #AB = longeur sqrt ((xB-xA)**2+(yB-yA)**2) <=(version obsolète)
    AB = longeur(xA,yA,xB,yB)
    print(AB)
    print(AB**2)
    BC = sqrt ((xC-xB)**2+(yC-yB)**2)
    print(BC)
    print(BC**2)
    AC = sqrt ((xA-xC)**2+(yA-yC)**2)
    print(AC)
    print(AC**2)
    if AC**2+BC**2 == AB**2:
        return 1
    else:
        return 0

#CH4
def parraléllogramme(xA,yA,xB,yB,xC,yC,xD,yD):
    P = milieu (xA,yA,xC,yC)
    M = milieu2 (xD,yD,xB,yB)
    if P == M:
        return 1
    else:
        return 0
    
#CH4bis
def rectangle (xA,yA,xB,yB,xC,yC,xD,yD):
    if Trectangle (xA,yA,xB,yB,xC,yC)==1 and parraléllogramme(xA,yA,xB,yB,xC,yC,xD,yD)==1:
        return "le quadrilatère est rectangle"
    else:
        return "le quadrilatère n'est pas un rectangle"
    


xA = extrem(car)[0]; yA = extrem(car)[1]
xB = extrem(car)[2]; yB = extrem(car)[3]
xC = extrem(car)[4]; yC = extrem(car)[5]
xD = extrem(car)[6]; yD = extrem(car)[7]

print("le quadrilatère vert est-il un rectangle ?",rectangle (xA,yA,xB,yB,xC,yC,xD,yD))
        
    

